Codeforces Round 924 (Div. 2)---->B. Equalize

2024-03-13 02:12

本文主要是介绍Codeforces Round 924 (Div. 2)---->B. Equalize,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

总思路:首先我们做这题的时候有两个点一定要知道:

1.当数组中有重复元素的时候,只有其中的一个才能贡献一个相同元素,其他的都不行(因为是排列,一个数只出现一次),所以我们可以用使用去重函数。——>去重的两种方法

2.出现次数最多的元素,一定是 arr[i]数组中某个元素加上排列的某个值形成的。当然这个值我们是无法确定的,但是这个元素是加上元素的那个数而成的我们可以根据贪心思维求得。

3.这个数一定是加上排列中的1形成的,为什么呢?首先我们要知道当两个数之间的差距 大于 n (排列长度),是一定不会被凑出来的,所以当一个数加上1,那么这个差距是最小的,能拼凑出相同元素的个数也是最多的。

一,方法一:双指针

#include <iostream>
#include<cstring>
#include<algorithm>
using namespace std;const int N=2e5+10;int arr[N];void Solved(){int n;cin>>n;for(int i=0;i<n;i++) cin>>arr[i];sort(arr,arr+n);int m=unique(arr,arr+n)-arr;int cnt=0;for(int i=0,j=0;i<m;i++){while(j<m&&arr[i]+1-arr[j]>n){j++;}cnt=max(cnt,i-j+1);}cout<<cnt<<endl;
}int main()
{int t;cin>>t;while(t--) {Solved();}return 0;
}

二,二分(思路和双指针一样,可能比双指针更好理解点)

1.代码:

#include <iostream>
#include<cstring>
#include<algorithm>
using namespace std;const int N=2e5+10;int arr[N];void Solved(){int n;cin>>n;for(int i=0;i<n;i++) cin>>arr[i];sort(arr,arr+n);int m=unique(arr,arr+n)-arr;int cnt=0;for(int i=0;i<m;i++){int l=0,r=i;//二分模版while(l<r){int mid=(l+r)>>1;if(arr[i]+1-arr[mid]<=n) r=mid;else l=mid+1;}cnt=max(cnt,i-l+1);}cout<<cnt<<endl;}int main()
{int t;cin>>t;while(t--) {Solved();}return 0;
}

这篇关于Codeforces Round 924 (Div. 2)---->B. Equalize的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/803332

相关文章

Codeforces Round #240 (Div. 2) E分治算法探究1

Codeforces Round #240 (Div. 2) E  http://codeforces.com/contest/415/problem/E 2^n个数,每次操作将其分成2^q份,对于每一份内部的数进行翻转(逆序),每次操作完后输出操作后新序列的逆序对数。 图一:  划分子问题。 图二: 分而治之,=>  合并 。 图三: 回溯:

Codeforces Round #261 (Div. 2)小记

A  XX注意最后输出满足条件,我也不知道为什么写的这么长。 #define X first#define Y secondvector<pair<int , int> > a ;int can(pair<int , int> c){return -1000 <= c.X && c.X <= 1000&& -1000 <= c.Y && c.Y <= 1000 ;}int m

Codeforces Beta Round #47 C凸包 (最终写法)

题意慢慢看。 typedef long long LL ;int cmp(double x){if(fabs(x) < 1e-8) return 0 ;return x > 0 ? 1 : -1 ;}struct point{double x , y ;point(){}point(double _x , double _y):x(_x) , y(_y){}point op

Codeforces Round #113 (Div. 2) B 判断多边形是否在凸包内

题目点击打开链接 凸多边形A, 多边形B, 判断B是否严格在A内。  注意AB有重点 。  将A,B上的点合在一起求凸包,如果凸包上的点是B的某个点,则B肯定不在A内。 或者说B上的某点在凸包的边上则也说明B不严格在A里面。 这个处理有个巧妙的方法,只需在求凸包的时候, <=  改成< 也就是说凸包一条边上的所有点都重复点都记录在凸包里面了。 另外不能去重点。 int

Codeforces 482B 线段树

求是否存在这样的n个数; m次操作,每次操作就是三个数 l ,r,val          a[l] & a[l+1] &......&a[r] = val 就是区间l---r上的与的值为val 。 也就是意味着区间[L , R] 每个数要执行 | val 操作  最后判断  a[l] & a[l+1] &......&a[r] 是否= val import ja

CSS实现DIV三角形

本文内容收集来自网络 #triangle-up {width: 0;height: 0;border-left: 50px solid transparent;border-right: 50px solid transparent;border-bottom: 100px solid red;} #triangle-down {width: 0;height: 0;bor

创建一个大的DIV,里面的包含两个DIV是可以自由移动

创建一个大的DIV,里面的包含两个DIV是可以自由移动 <body>         <div style="position: relative; background:#DDF8CF;line-height: 50px"> <div style="text-align: center; width: 100%;padding-top: 0px;"><h3>定&nbsp;位&nbsp;

Codeforces Round 971 (Div. 4) (A~G1)

A、B题太简单,不做解释 C 对于 x y 两个方向,每一个方向至少需要 x / k 向上取整的步数,取最大值。 由于 x 方向先移动,假如 x 方向需要的步数多于 y 方向的步数,那么最后 y 方向的那一步就不需要了,答案减 1 代码 #include <iostream>#include <algorithm>#include <vector>#include <string>

CF#271 (Div. 2) D.(dp)

D. Flowers time limit per test 1.5 seconds memory limit per test 256 megabytes input standard input output standard output 题目链接: http://codeforces.com/contest/474/problem/D We s

CF #278 (Div. 2) B.(暴力枚举+推导公式+数学构造)

B. Candy Boxes time limit per test 1 second memory limit per test 256 megabytes input standard input output standard output 题目链接: http://codeforces.com/contest/488/problem/B There